{-|
Module      : Gargantext.API.NodeAuth
Description :
Copyright   : (c) CNRS, 2017-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

-}

{-# LANGUAGE CPP                        #-}
{-# LANGUAGE DataKinds                  #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE ScopedTypeVariables        #-}
{-# LANGUAGE TypeFamilies               #-}
{-# LANGUAGE TypeOperators              #-}

module Gargantext.API.NodeAuth where

import Servant.API ((:>))
import Servant.Links (HasLink (..))
import Protolude


data NodeAuth (nodeAuths :: [*]) user node

-- | A @HasLink@ instance for @NodeAuth@
instance HasLink sub => HasLink (NodeAuth (tag :: [*]) user node :> sub) where
  type MkLink (NodeAuth (tag :: [*]) user node :> sub) a = MkLink sub a
  toLink toA _ = toLink toA (Proxy :: Proxy sub)


-- | Validation that this node belongs to request user's node tree.
data NodeTree
